# RuPersonaAgent
![alt text for screen readers](https://itmo.ru/file/pages/213/logo_na_plashke_russkiy_belyy.png "Text to show on mouseover").

## The purpose of the project
The rupersonaagent library is designed for quick and easy development of a Russian-language personalized conversational agent with dynamic long-term memory. Each method and model can also be used separately for purposes other than developing a conversational agent.

## Table of Contents

-  [Core features](#core-features)
-  [Installation](#installation)
-  [Examples](#examples)
-  [Project Structure](#project-structure)
-  [Documentation](#documentation)
-  [License](#license)
-  [Acknowledgments](#acknowledgments)
-  [Contacts](#contacts)
-  [Citation](#citation)


## Core features


* Speech Extraction
* Generative Model
* Long-term and Internet memory
* Persona Knowledge Extraction
* Rule Based Information Extraction
* Inference Optimization




## Installation

RuPersonaAgent can be installed with ``pip``:

```
  $ pip install rupersonaagent
```

## Examples

[link for usage examples](https://habr.com/ru/companies/spbifmo/articles/755514/)


## Project Structure
Stable version is located in the main branch

Repo includes:

* generative_model - methods for creating and working with generative Russian language models
* speech_extraction - methods for extracting the main characteristics of speech from datasets or individual cues, a method for assessing the similarity of speech characteristics
* rule_based_information_extraction - methods for extracting important facts about a person from a text based on linguistic rules

## Documentation
[Documentation](https://gitlab.com/Iolly/rupersonaagent/-/wikis/Документация)


## License
[License](LICENSE)

## Acknowledgments
Gratitude to [ITMO University](https://itmo.ru) for sponsoring and supporting this project


## Contacts
[Telegram channel](<https://t.me/rupersonaagent>) Q&A RuPersonaAgent

## Citation


Матвеева А.А., Махныткина О.В. Метод аугментации текстовых данных с сохранением стиля речи и лексики персоны // Научно-технический вестник информационных технологий, механики и оптики. 2023. Т. 23, № 4. С. 743–749. doi: 10.17586/2226-1494-2023-23-4-743-749

Посохов П.А., Рудалева Е.А., Скрыльников С.С., Махныткина О.В., Кабаров В.И. Извлечение информации о персоне из диалоговых данных на русском языке //Информационные технологии. - 2023. в печати

